<?php

class Createview extends Controller{

    function Createview()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->library(array('table','pagination'));
      $this->load->model('createviewmodel');
    }

    function create()
    {
      set_time_limit(0);
      $list['0'] = 'Loading Started...';
      $this->session->set_userdata('progressList',$list);

      $data['ajaxURL1'] = site_url('createview/oldAjaxRequestStep');
      $data['ajaxURL2'] = site_url('createview/oldAjaxRequestDetail');
      //$data['ajaxURL'] = site_url('ajaxtest/uploadoldtrees');
      $data['ajaxURL'] = site_url('createview/createall');
      $data['totalSteps'] = "13";

      $data['buttonText'] = "Create";
      $data['whichData'] = "Please Hit the Create Button and Confirm To Create All View Tables.";
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Create View - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';

      $this->load->view('upload/uploadview',$data);
    }

    function createall()
    {
      set_time_limit(0);

      $this->createviewfull();

      $this->createtaxtemp();

      $this->concatspecies1();

      $this->concatspecies2();

      $this->concattemp2();
///////Update Status//////////////////////////////////
    $list['step'] = '13';
    $list['detail'] = '<span class="smallsuccess">Creating View Complete</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
///////////////////////////////////////////////////////
    }

    function createviewfull()
    {

///////Update Status//////////////////////////////////
    $list['step'] = '1';
    $list['detail'] = '<span class="smallsuccess">Creating, SGFTemp</span>';
    $list['detailList'] = $list['detail'];
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);     // Sleep is used to display the status properly
///////////////////////////////////////////////////////

      // Plot Records
      // Table structure for table `SGFtemp`
      $this->createviewmodel->SGFTemp();

///////Update Status//////////////////////////////////
    $list['step'] = '2';
    $list['detail'] = '<span class="smallsuccess">Creating, MPQTtemp</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      // Plot Records report
      // Table structure for table MPQTtemp
      $this->createviewmodel->MPQTtemp();

///////Update Status//////////////////////////////////
    $list['step'] = '3';
    $list['detail'] = '<span class="smallsuccess">Creating, ViewFullTable</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      // Table structure for table ViewFullTable: the primary temporary table housing all measurements of every stem in every census, joined to species name,
      // plot name, and census number (ie, all in one table). It is built using the previous 2 tables, which are now (Oct 2008) dropped after this table is
      // finished
      $this->createviewmodel->viewFullTable();


///////Update Status//////////////////////////////////
    $list['step'] = '4';
    $list['detail'] = '<span class="smallsuccess">Updating ListOfTSM</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      // The following restrict the query to measurements where there is an attribute. This is often well below half of measurements
      $dbhQuery = $this->createviewmodel->getDBHData();

      if($dbhQuery->num_rows() > 0)
      {
        foreach($dbhQuery->result_array() as $dbhRow)
        {
          $dbhID = trim($dbhRow['DBHID']);
          $censusID = trim($dbhRow['CensusID']);

          $tsmQuery = $this->createviewmodel->getTSMData($dbhID,$censusID);

          $listOfTSM = '';
          $firstTime = 0;

          if($tsmQuery->num_rows() > 0)
          {
            foreach($tsmQuery->result_array() as $tsmRow)
            {
              $tsmCode = trim($tsmRow['TSMCode']);
              if($FirstTime == 0)
              {
            	$listOfTSM = $tsmCode;
                $firstTime = 1;
              }
              else
              {
            	$listOfTSM = $listOfTSM.",".$tsmCode;
              }
            }

            $this->createviewmodel->updVFTListOfTSM($dbhID,$censusID,$listOfTSM);
          }
        }
      }
///////Update Status//////////////////////////////////
    $list['step'] = '5';
    $list['detail'] = '<span class="smallsuccess">Updating Status</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      //Calculate status field for each ViewFullTable record
      $this->createviewmodel->updStatus();

///////Update Status//////////////////////////////////
    $list['step'] = '6';
    $list['detail'] = '<span class="smallsuccess">ViewFullTable Created.</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////
    }

    function createtaxtemp()
    {
///////Update Status//////////////////////////////////
    $list['step'] = '7';
    $list['detail'] = '<span class="smallsuccess">Creating, TAX1temp</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      // This creates a table called TAX1temp which has all species in CurrentTaxonomyTable, collecting subspecies and
      // adding a variable for all old names
      // Table structure for table `TAX1temp`
      $this->createviewmodel->tax1temp();

///////Update Status//////////////////////////////////
    $list['step'] = '8';
    $list['detail'] = '<span class="smallsuccess">Creating, TAX2temp</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      // This creates a table called TAX2temp with all obsolete species names along with the current name of each
      // Table structure for table `TAX2temp`
      $this->createviewmodel->tax2temp();

///////Update Status//////////////////////////////////
    $list['step'] = '9';
    $list['detail'] = '<span class="smallsuccess">Creating, TAX3temp</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      // This creates a table called TAX3temp which collects every current species name with every plot
      // or inventory the species is known from. It queries both PlotInventory and TreeTaxonomy tables.
      // Table structure for table `TAX3temp`
      $this->createviewmodel->tax3temp();
    }

    function concatspecies1()
    {
///////Update Status//////////////////////////////////
    $list['step'] = '10';
    $list['detail'] = '<span class="smallsuccess">Updating ListOfHerbarium</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      $getSpecies = $this->createviewmodel->getSpeciesIDs();
      if($getSpecies->num_rows() > 0)
      {
        foreach($getSpecies->result_array() as $speciesRow)
        {
          $speciesID = trim($speciesRow['SpeciesID']);
          $numberOfHerbarium = 0;
      	  $listOfHerbarium = '';
      	  $firstTime = 0;

          $getHerbarium = $this->createviewmodel->getHerbarium($speciesID);
          $numberOfHerbarium = $getHerbarium->num_rows();
          if($numberOfHerbarium > 0)
          {
            foreach($getHerbarium->result_array() as $herbariumRow)
            {
              $herbarium = trim($herbariumRow['Herbarium']);
              if($firstTime == 0)
              {
                $listOfHerbarium = $herbarium;
               	$firstTime = 1;
              }
              else
              {
                $listOfHerbarium = $listOfHerbarium.",".$herbarium;
              }
            }
            $this->createviewmodel->updListOfHerbarium($speciesID,$numberOfHerbarium,$listOfHerbarium);
          }
        }
      }
    }

    function concatspecies2()
    {
///////Update Status//////////////////////////////////
    $list['step'] = '11';
    $list['detail'] = '<span class="smallsuccess">Updating TAX1temp for List of Old Names</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////
      $getSpecies = $this->createviewmodel->getSpeciesIDs();
      if($getSpecies->num_rows() > 0)
      {
        foreach($getSpecies->result_array() as $speciesRow)
        {
          $speciesID = trim($speciesRow['SpeciesID']);
          $startingSpeciesID = $speciesID;
      	  $listOfOldNames = '';
      	  $firstTime = 0;
      	  $head = 0;
      	  $tail = 0;
      	  $queue = '';

          //ExpandSpecie
          $getSpeciesData = $this->createviewmodel->getSpeciesData($speciesID);
          if($getSpeciesData->num_rows() > 0)
          {
            $rowSpecies['SpeciesName'] = '';
            foreach($getSpeciesData->result_array() as $rowSpecies)
            {
              $speciesName = trim($rowSpecies['SpeciesName'],"'");
			  $rowSpecies['SpeciesName'] = '';
			  $genusID = trim($rowSpecies['GenusID'],"'");

              $getGenus = $this->createviewmodel->getGensus($genusID);
              $rowGenus = $getGenus->row_array();
              $genusName = trim($rowGenus['Genus'],"'");

              if($firstTime == 0)
              {
                $listOfOldNames = $genusName." ".$speciesName;
                $firstTime = 1;
              }
              else
              {
                $listOfOldNames = $listOfOldNames.",".$genusName." ".$speciesName;
              }
              // Build Queue
			  $obsoleteSpeciesID = trim($rowSpecies['ObsoleteSpeciesID'],"'");
			  $queue[$tail] = $obsoleteSpeciesID;
			  $tail = $tail + 1;
            }
          }
          /////////////////////
          while (($head < $tail) AND ($tail != 0))
	      {
	        // pop top ObsoleteSpeciesID and make CO.SpeciesID
		    $speciesID = $queue[$head];
		    $head = $head + 1;

            //ExpandSpecie
            $getSpeciesData = $this->createviewmodel->getSpeciesData($speciesID);
            if($getSpeciesData->num_rows() > 0)
            {
              $rowSpecies['SpeciesName'] = '';
              foreach($getSpeciesData->result_array() as $rowSpecies)
              {
                $speciesName = trim($rowSpecies['SpeciesName'],"'");
  			  $rowSpecies['SpeciesName'] = '';
  			  $genusID = trim($rowSpecies['GenusID'],"'");

                $getGenus = $this->createviewmodel->getGensus($genusID);
                $rowGenus = $getGenus->row_array();
                $genusName = trim($rowGenus['Genus'],"'");

                if($firstTime == 0)
                {
                  $listOfOldNames = $genusName." ".$speciesName;
                  $firstTime = 1;
                }
                else
                {
                  $listOfOldNames = $listOfOldNames.",".$genusName." ".$speciesName;
                }
                // Build Queue
  			  $obsoleteSpeciesID = trim($rowSpecies['ObsoleteSpeciesID'],"'");
  			  $queue[$tail] = $obsoleteSpeciesID;
  			  $tail = $tail + 1;
              }
            }
            /////////////////////
          }
          //update the TAX1temp table with ListOfOldNames
          $this->createviewmodel->updTax1temp($listOfOldNames,$startingSpeciesID);
        }
      }
    }

    function concattemp2()
    {
///////Update Status//////////////////////////////////
    $list['step'] = '12';
    $list['detail'] = '<span class="smallsuccess">Updating, TAX2temp for Old Genus Name</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////
      $getTAX2temp = $this->createviewmodel->getTAX2temp();

      if($getTAX2temp->num_rows() > 0)
      {
        foreach($getTAX2temp->result_array() as $rowTAX2temp)
        {
          $speciesID = $rowTAX2temp['SpeciesID'];
	      $obsoleteSpeciesID = $rowTAX2temp['ObsoleteSpeciesID'];
	      $obsoleteSpeciesName = trim($rowTAX2temp['ObsoleteSpeciesName']);
	      $obsoleteSpeciesName = addslashes($obsoleteSpeciesName);

          $getGenus = $this->createviewmodel->getGenusName($obsoleteSpeciesID);
          $rowGenus = $getGenus->row_array();
          $oldGenusName = trim($rowGenus['Genus']);
          $oldGenusName = addslashes($oldGenusName);

          // update the TAX2temp table with Old Genus Name
          $this->createviewmodel->updTax2temp($oldGenusName,$obsoleteSpeciesName,$speciesID,$obsoleteSpeciesID);
        }
      }
    }

    function oldAjaxRequestStep()
    {
      $list = $this->session->userdata('progressList');
      $step = $list['step'];
      echo $step;
    }
    function oldAjaxRequestDetail()
    {
      $list = $this->session->userdata('progressList');
      $detail = $list['detail'];
      $detailList = $list['detailList'];
      echo $detailList;
    }

    function test()
    {
      echo "hello";
    }
}